image: docker:20.10

variables:
  # When using dind service we need to instruct docker, to talk with
  # the daemon started inside of the service. The daemon is
  # available with a network connection instead of the default
  # /var/run/docker.sock socket. docker:19.03-dind does this
  # automatically by setting the DOCKER_HOST in
  # https://github.com/docker-library/docker/blob/d45051476babc297257df490d22cbd806f1b11e4/19.03/docker-entrypoint.sh#L23-L29
  #
  # The 'docker' hostname is the alias of the service container as described at
  # https://docs.gitlab.com/ee/ci/docker/using_docker_images.html#accessing-the-services.
  #
  # Note that if you're using the Kubernetes executor, the variable should be set to
  # tcp://localhost:2376/ because of how the Kubernetes executor connects services
  # to the job container
  # DOCKER_HOST: tcp://localhost:2376/
  #
  # When using dind, it's wise to use the overlayfs driver for
  # improved performance.
  DOCKER_DRIVER: overlay2
  # Specify to Docker where to create the certificates, Docker will
  # create them automatically on boot, and will create
  # `/certs/client` that will be shared between the service and
  # build container.
  DOCKER_TLS_CERTDIR: "/certs"

  DEPLOY_HOST: 176.112.217.113

services:
  - docker:20.10-dind

stages:
  - build production
  - deploy

build production app image:
  stage: build production
  before_script:
    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN registry.gitlab.com
  script:
    - docker pull $CI_REGISTRY_IMAGE:production || true
    - docker build --cache-from $CI_REGISTRY_IMAGE:production
                   --tag $CI_REGISTRY_IMAGE:production
                   --build-arg revision=$CI_COMMIT_SHA
                   -f .swarm/Dockerfile .
    - docker push $CI_REGISTRY_IMAGE:production
  only:
    - main

deploy:
  stage: deploy
  before_script:
    - eval $(ssh-agent -s)
    - echo "$SSH_PRIVATE_KEY" | tr -d '\r' | ssh-add - > /dev/null
    - mkdir -p ~/.ssh && echo -e "Host $DEPLOY_HOST\nUser root\nPort 22\n\nHost *\nStrictHostKeyChecking no\nForwardAgent yes\n" > ~/.ssh/config
  script:
    - scp .swarm/docker-compose.yml $DEPLOY_HOST:/root/.swarm/
    - ssh $DEPLOY_HOST 'docker stack deploy -c .swarm/docker-compose.yml --resolve-image=always --with-registry-auth --prune testbed3'
  only:
    - main
